<script lang="ts">
	import Button from '$lib/components/Button.svelte';
	import ChifoumiSocket from '$lib/components/ChifoumiSocket.svelte';
	import type { Game, User } from '$lib/domains/RPS.type.ts';
	import { getSocket } from '$lib/services/socket.js';
	import type { Socket } from 'socket.io-client';
	import { onMount } from 'svelte';

	export let data;

	let socket: Socket | null = null;
	let game: Game | null = null;
	let user: User = {
		name: '',
		id: ''
	};
	let copyLinkText = 'Copy the link to the game';

	onMount(async () => {
		socket = getSocket();
		socket.on('game update', (newGame: Game) => {
			game = newGame;
		});

		socket.emit('join game', data.gameId);
		socket.on('game joined', (newGame: Game) => {
			game = newGame;
		});
		socket.on('game not found', () => {
			console.log("game not found");
		});

		user = {
			name: localStorage.getItem('name') || '',
			id: localStorage.getItem('id') || ''
		};
	});

	function copyLink() {
		const link = window.location.href;
		navigator.clipboard.writeText(link);
		copyLinkText = 'Link copied!';
		setTimeout(() => {
			copyLinkText = 'Copy the link to the game';
		}, 2000);
	}
</script>

{#if game}
	{#if game.players.length === 1 && game.players[0].id === user?.id}
		<div class="waiting">
			<h2>Game - {data.gameId}</h2>
			<div>
				<p class="share">Share the link of the page with a friend to play with them</p>
			</div>
			<Button on:click={copyLink}>{copyLinkText}</Button>
			<p>Waiting for an opponent...</p>
		</div>
	{:else}
		<ChifoumiSocket {game} {user} />
	{/if}
{:else}
	<p class="waiting">Loading...</p>
{/if}

<style>
	.waiting h2 {
		margin: 1rem 0;
	}
	.waiting > p {
		margin: 2rem 0;
	}
	.waiting {
		text-align: center;
		text-wrap: balance;
	}

	.share {
		margin: 0.5rem 0;
		line-height: 100%;
	}
</style>
